<?xml version='1.0' ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:uml="http://schema.omg.org/spec/UML/2.0" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
	<xsl:output method="xml" indent="yes" encoding = "UTF-8"/>

	<xsl:variable name="ProfilePrefix">
		<xsl:text>U2F0TW90aW9uQXBwbGljYXRpb25fMA__:MadamProfile__</xsl:text>
	</xsl:variable>

	<xsl:variable name="ProfileID">
		<xsl:text>_iXAad4PGEduaib1rbQg5jQ</xsl:text>
	</xsl:variable>

	<xsl:variable name="ProfileFile">
		<xsl:text>MadamProfile.profile.uml2#_iXAZcIPGEduaib1rbQg5jQ</xsl:text>
	</xsl:variable>


	<xsl:template match="text()|@*">
		<xsl:value-of select="."/>
	</xsl:template>
	
	<xsl:template match="text()|@*"/>
	
	<xsl:template match="xmi:XMI">
		<xsl:apply-templates select="uml:Model"/>
	</xsl:template>
	
	<xsl:template match="uml:Model">
		<uml:Model xmi:version="2.0" 
			xmlns:xmi="http://www.omg.org/XMI" 
			xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
			xmlns:U2F0TW90aW9uQXBwbGljYXRpb25fMA__="http:///MadamProfile_0_iTbhAIPGEduaib1rbQg5jQ.profile.uml2"
			xmlns:uml="http://www.eclipse.org/uml2/1.0.0/UML" 
			xsi:schemaLocation="http:///MadamProfile_0_iTbhAIPGEduaib1rbQg5jQ.profile.uml2 MadamProfile.profile.uml2#_iXAZdIPGEduaib1rbQg5jQ" 
			xmi:id="_iXAadoPGEduaib1rbQg5jQ">			
			<xsl:attribute name="name">
				<xsl:value-of select="@name"/>
			</xsl:attribute>
			<xsl:attribute name="xmi:type">
				<xsl:value-of select="@xmi:type" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="appliedProfile">
				<xsl:value-of select="$ProfileID"/>
			</xsl:attribute>
			<packageImport xmi:type="uml:ProfileApplication">
				<xsl:attribute name="xmi:id">
					<xsl:value-of select="$ProfileID"/>
				</xsl:attribute>
   				<eAnnotations xmi:id="_iXAaeIPGEduaib1rbQg5jQ" source="attributes">
					<xsl:attribute name="xmi:id">
						<xsl:value-of select="$ProfileID"/><xsl:text>AN</xsl:text>
					</xsl:attribute>
					<details key="version" value="0">
						<xsl:attribute name="xmi:id">
							<xsl:value-of select="$ProfileID"/><xsl:text>DET</xsl:text>
						</xsl:attribute>
					</details>

				</eAnnotations>
    				<importedPackage xmi:type="uml:Profile">
					<xsl:attribute name="href">
						<xsl:value-of select="$ProfileFile"/>					
					</xsl:attribute>
 				</importedPackage>
				<importedProfile>
					<xsl:attribute name="href">
						<xsl:value-of select="$ProfileFile"/>					
					</xsl:attribute>
				</importedProfile>
			</packageImport>
			<xsl:apply-templates select="ownedMember[@xmi:type='uml:Package']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
		</uml:Model>
	</xsl:template>
	
	<xsl:template match="ownedMember[@xmi:type='uml:Package']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
		<ownedMember>
			<xsl:attribute name="xmi:type">
				<xsl:value-of select="@xmi:type" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="xmi:id">
				<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:value-of select="@name"/>
			</xsl:attribute>
			<xsl:attribute name="visibility">
				<xsl:value-of select="@visibility"/>
			</xsl:attribute>
			<xsl:apply-templates select="ownedMember[@xmi:type='uml:Package']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			<xsl:apply-templates select="ownedMember[@xmi:type='uml:Class']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			<xsl:apply-templates select="ownedElement[@xmi:type='uml:Realization']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			<xsl:apply-templates select="ownedElement[@xmi:type='uml:Dependency']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			<xsl:apply-templates select="ownedMember[@xmi:type='uml:Association']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			<xsl:apply-templates select="ownedMember[@xmi:type='uml:Node']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			<xsl:apply-templates select="ownedMember[@xmi:type='uml:Constraint']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			<xsl:call-template name="AddStereotypes">
				<xsl:with-param name="elementID" select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:call-template>			
		</ownedMember>
	</xsl:template>
	<xsl:template match="ownedMember[@xmi:type='uml:Class']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
		<ownedMember>
			<xsl:attribute name="xmi:type">
				<xsl:value-of select="@xmi:type" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="xmi:id">
				<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:value-of select="@name"/>
			</xsl:attribute>
			<xsl:attribute name="visibility">
				<xsl:value-of select="@visibility"/>
			</xsl:attribute>
			<xsl:apply-templates select="nestedClassifier[@xmi:type='uml:Class']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			<xsl:apply-templates select="ownedPort[@xmi:type='uml:Port']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			<xsl:apply-templates select="ownedAttribute[@xmi:type='uml:Property']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			<xsl:apply-templates select="ownedConnector[@xmi:type='uml:Connector']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			<xsl:call-template name="AddClassConstraints">
				<xsl:with-param name="elementID" select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:call-template>
			<xsl:call-template name="AddAssociationRoles">
				<xsl:with-param name="elementID" select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:call-template>
			<xsl:call-template name="AddStereotypes">
				<xsl:with-param name="elementID" select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:call-template>
		</ownedMember>
	</xsl:template>
	<xsl:template match="ownedElement[@xmi:type='uml:Realization']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
		<ownedMember>
			<xsl:attribute name="xmi:type">
				<xsl:text>uml:Dependency</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="xmi:id">
				<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:value-of select="@name"/>
			</xsl:attribute>
			<xsl:attribute name="supplier">
				<xsl:value-of select="@supplier"/>
			</xsl:attribute>
			<xsl:attribute name="client">
				<xsl:value-of select="@client"/>
			</xsl:attribute>
		</ownedMember>
	</xsl:template>
	<xsl:template match="ownedElement[@xmi:type='uml:Dependency']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
		<ownedMember>
			<xsl:attribute name="xmi:type">
				<xsl:value-of select="@xmi:type" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="xmi:id">
				<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:value-of select="@name"/>
			</xsl:attribute>
			<xsl:attribute name="supplier">
				<xsl:value-of select="@supplier"/>
			</xsl:attribute>
			<xsl:attribute name="client">
				<xsl:value-of select="@client"/>
			</xsl:attribute>
		</ownedMember>
	</xsl:template>
	
	<xsl:template match="nestedClassifier[@xmi:type='uml:Class']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
		<nestedClassifier>
			<xsl:attribute name="xmi:type">
				<xsl:value-of select="@xmi:type" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="xmi:id">
				<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:value-of select="@name"/>
			</xsl:attribute>
			<xsl:attribute name="visibility">
				<xsl:value-of select="@visibility"/>
			</xsl:attribute>
			<xsl:apply-templates select="nestedClassifier[@xmi:type='uml:Class']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			<xsl:apply-templates select="ownedPort[@xmi:type='uml:Port']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			<xsl:apply-templates select="ownedAttribute[@xmi:type='uml:Property']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			<xsl:apply-templates select="ownedConnector[@xmi:type='uml:Connector']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			<xsl:call-template name="AddAssociationRoles">
				<xsl:with-param name="elementID" select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:call-template>
			<xsl:call-template name="AddStereotypes">
				<xsl:with-param name="elementID" select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:call-template>
		</nestedClassifier>
	</xsl:template>

	<xsl:template match="ownedPort[@xmi:type='uml:Port']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
		<ownedPort>
			<xsl:attribute name="xmi:type">
				<xsl:value-of select="@xmi:type" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="xmi:id">
				<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:value-of select="@name"/>
			</xsl:attribute>
			<xsl:attribute name="visibility">
				<xsl:value-of select="@visibility"/>
			</xsl:attribute>
			<xsl:attribute name="aggregation">
				<xsl:value-of select="@aggregation"/>
			</xsl:attribute>
			<xsl:attribute name="end">
				<xsl:call-template name="AddConnectorEnd">
					<xsl:with-param name="roleID" select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
				</xsl:call-template>
			</xsl:attribute>			
		</ownedPort>
	</xsl:template>
	<xsl:template match="ownedAttribute[@xmi:type='uml:Property']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
		<ownedAttribute>
			<xsl:attribute name="xmi:type">
				<xsl:value-of select="@xmi:type" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="xmi:id">
				<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:value-of select="@name"/>
			</xsl:attribute>
			<xsl:choose>	
				<xsl:when test="qualifier/@xmi:type='uml:Port'" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
					<xsl:attribute name="visibility">
						<xsl:value-of select="@visibility"/>
					</xsl:attribute>
					<xsl:attribute name="aggregation">
						<xsl:value-of select="@aggregation"/>
					</xsl:attribute>
					<xsl:call-template name="AddStereotypes">
						<xsl:with-param name="elementID" select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
					</xsl:call-template>
					<xsl:apply-templates select="qualifier[@xmi:type='uml:Port']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>			
				</xsl:when>
				<xsl:otherwise>
					<xsl:if test="string-length(type/@xmi:idref) &gt; 0" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
						<xsl:call-template name="AddAttributeType">
							<xsl:with-param name="elementIDREF" select="type/@xmi:idref" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
						</xsl:call-template>
					</xsl:if>	
					<xsl:if test="string-length(type/@xmi:idref) = 0" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
						<xsl:call-template name="AddAttributeType2">
							<xsl:with-param name="elementIDREF" select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
						</xsl:call-template>
					</xsl:if>	
					<lowerValue>
						<xsl:attribute name="xmi:type">
							<xsl:value-of select="lowerValue/@xmi:type" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
						</xsl:attribute>
						<xsl:attribute name="xmi:id">
							<xsl:value-of select="lowerValue/@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
						</xsl:attribute>
						<xsl:attribute name="value">
							<xsl:value-of select="lowerValue/@value"/>
						</xsl:attribute>				
					</lowerValue>
					<upperValue>
						<xsl:attribute name="xmi:type">
							<xsl:value-of select="upperValue/@xmi:type" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
						</xsl:attribute>
						<xsl:attribute name="xmi:id">
							<xsl:value-of select="upperValue/@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
						</xsl:attribute>
						<xsl:attribute name="value">
							<xsl:value-of select="upperValue/@value"/>
						</xsl:attribute>								
					</upperValue>
					<defaultValue>
						<xsl:attribute name="xmi:type">
							<xsl:text>uml:LiteralString</xsl:text>
						</xsl:attribute>
						<xsl:attribute name="xmi:id">
							<xsl:value-of select="defaultValue/@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
						</xsl:attribute>
						<xsl:attribute name="value">
							<xsl:value-of select="defaultValue/@value"/>
						</xsl:attribute>												
					</defaultValue>
					<xsl:call-template name="AddStereotypesAttributes">
						<xsl:with-param name="elementID" select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</ownedAttribute>
	</xsl:template>

	<xsl:template match="qualifier[@xmi:type='uml:Port']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
		<qualifier>
			<xsl:attribute name="xmi:type">
				<xsl:value-of select="@xmi:type" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="xmi:id">
				<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:value-of select="@name"/>
			</xsl:attribute>
			<xsl:attribute name="visibility">
				<xsl:value-of select="@visibility"/>
			</xsl:attribute>
			<xsl:attribute name="aggregation">
				<xsl:value-of select="@aggregation"/>
			</xsl:attribute>
			<xsl:attribute name="end">
				<xsl:call-template name="AddConnectorEnd">
					<xsl:with-param name="roleID" select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
				</xsl:call-template>
			</xsl:attribute>			
		</qualifier>
	</xsl:template>

	<xsl:template match="ownedConnector[@xmi:type='uml:Connector']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
		<ownedConnector>
			<xsl:attribute name="xmi:type">
				<xsl:value-of select="@xmi:type" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="xmi:id">
				<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="visibility">
				<xsl:value-of select="@visibility"/>
			</xsl:attribute>
			<xsl:apply-templates select="end[@xmi:type='uml:ConnectorEnd']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
		</ownedConnector>
	</xsl:template>
	
	<xsl:template match="end[@xmi:type='uml:ConnectorEnd']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
		<end>
			<xsl:attribute name="xmi:type">
				<xsl:value-of select="@xmi:type" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="xmi:id">
				<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="role">
				<xsl:value-of select="@role"/>
			</xsl:attribute>
		</end>
	</xsl:template>

	<xsl:template match="ownedMember[@xmi:type='uml:Association']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
		<xsl:variable name="myAssID" select=" @xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
		<ownedMember>
			<xsl:attribute name="xmi:type">
				<xsl:value-of select="@xmi:type" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="xmi:id">
				<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:value-of select="@name" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="memberEnd">
				<xsl:for-each select="ownedEnd/type">
					<xsl:value-of select="$myAssID" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
					<xsl:if test="position()!=last()"><xsl:text>FI </xsl:text></xsl:if>
					<xsl:if test="position()=last()"><xsl:text>FILA</xsl:text></xsl:if>
				</xsl:for-each>
			</xsl:attribute>
		</ownedMember>
	</xsl:template>

	<xsl:template match="ownedMember[@xmi:type='uml:Node']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
		<ownedMember>
			<xsl:attribute name="xmi:type">
				<xsl:value-of select="@xmi:type" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="xmi:id">
				<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:value-of select="@name"/>
			</xsl:attribute>
			<xsl:attribute name="visibility">
				<xsl:value-of select="@visibility"/>
			</xsl:attribute>
			<xsl:attribute name="clientDependency">
				<xsl:for-each select="nestedClassifier[@xmi:type='uml:Component']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
					<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
					<xsl:if test="position()!=last()">
						<xsl:text> </xsl:text>
					</xsl:if>
				</xsl:for-each>
			</xsl:attribute>
			<xsl:call-template name="AddDeployments">
				<xsl:with-param name="elementID" select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:call-template>
			<xsl:apply-templates select="nestedNode[@xmi:type='uml:Node']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			<xsl:call-template name="AddStereotypes">
				<xsl:with-param name="elementID" select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:call-template>
		</ownedMember>
		<xsl:call-template name="AddDeploymentsAsArtifacts"/>
	</xsl:template>
	
	<xsl:template match="nestedNode[@xmi:type='uml:Node']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
		<nestedNode>
			<xsl:attribute name="xmi:type">
				<xsl:value-of select="@xmi:type" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="xmi:id">
				<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:value-of select="@name"/>
			</xsl:attribute>
			<xsl:attribute name="visibility">
				<xsl:value-of select="@visibility"/>
			</xsl:attribute>
			<xsl:attribute name="clientDependency">
				<xsl:for-each select="nestedClassifier[@xmi:type='uml:Component']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
					<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
					<xsl:if test="position()!=last()">
						<xsl:text> </xsl:text>
					</xsl:if>
				</xsl:for-each>
			</xsl:attribute>			
			<xsl:call-template name="AddDeployments">
				<xsl:with-param name="elementID" select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:call-template>
			<xsl:apply-templates select="nestedNode[@xmi:type='uml:Node']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			<xsl:call-template name="AddStereotypes">
				<xsl:with-param name="elementID" select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:call-template>
		</nestedNode>
	</xsl:template>

	<xsl:template match="ownedMember[@xmi:type='uml:Constraint']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
		<ownedRule>
			<xsl:attribute name="xmi:id">
				<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:text>ConstraintName</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="packageableElement_visibility">
				<xsl:text>private</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="constrainedElement">
				<xsl:value-of select="constrainedElement/@xmi:idref" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:attribute>
			<specification>
				<xsl:attribute name="xmi:type">
					<xsl:value-of select="specification/@xmi:type" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
				</xsl:attribute>
				<xsl:attribute name="xmi:id">
					<xsl:value-of select="specification/@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
				</xsl:attribute>
				<xsl:attribute name="language">
					<xsl:text>text</xsl:text>
				</xsl:attribute>
				<body>
					<xsl:value-of select="specification/body"/>	
				</body>
			</specification>
			<xsl:call-template name="AddStereotypes">
				<xsl:with-param name="elementID" select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			</xsl:call-template>
		</ownedRule>
	</xsl:template>

	
	<xsl:template name="AddConnectorEnd">
		<xsl:param name="roleID"/>
		<xsl:for-each select="../ownedConnector">
			<xsl:call-template name="AddConnectorEnd2">
				<xsl:with-param name="roleID" select="$roleID"/>
			</xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="../../ownedConnector">
			<xsl:call-template name="AddConnectorEnd2">
				<xsl:with-param name="roleID" select="$roleID"/>
			</xsl:call-template>
		</xsl:for-each>	
		<xsl:variable name="memberID" select="../@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
		<xsl:for-each select="../../ownedMember/ownedConnector">
			<xsl:if test="../@xmi:id!=$memberID" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
				<xsl:call-template name="AddConnectorEnd2">
					<xsl:with-param name="roleID" select="$roleID"/>
				</xsl:call-template>
			</xsl:if>
		</xsl:for-each>				
	</xsl:template>

	<xsl:template name="AddConnectorEnd2">
		<xsl:param name="roleID"/>
		<xsl:for-each select="end">
			<xsl:if test="$roleID=@role">
				<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/><xsl:text> </xsl:text>
			</xsl:if>
		</xsl:for-each>		
	</xsl:template>
	
	<xsl:template name="AddDeploymentsAsArtifacts">
		<xsl:for-each select="nestedClassifier[@xmi:type='uml:Component']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
			<ownedMember>
				<xsl:attribute name="xmi:type">
					<xsl:text>uml:Artifact</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="xmi:id">
					<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/><xsl:text>AR</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="name">
					<xsl:value-of select="@name"/>
				</xsl:attribute>
				<xsl:call-template name="AddStereotypes">
					<xsl:with-param name="elementID" select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
				</xsl:call-template>
			</ownedMember>
		</xsl:for-each>
		<xsl:for-each select="nestedNode[@xmi:type='uml:Node']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
			<xsl:call-template name="AddDeploymentsAsArtifacts"/>
		</xsl:for-each>
	</xsl:template>

	<xsl:template name="AddDeployments">
		<xsl:param name="elementID"/>
		<xsl:for-each select="nestedClassifier[@xmi:type='uml:Component']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
			<deployment>
				<xsl:attribute name="xmi:id">
					<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
				</xsl:attribute>
				<xsl:attribute name="name">
					<xsl:text>Unbekannter Name</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="client">
					<xsl:value-of select="$elementID"/>
				</xsl:attribute>
				<xsl:attribute name="supplier">
					<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/><xsl:text>AR</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="deployedArtifact">
					<xsl:value-of select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/><xsl:text>AR</xsl:text>
				</xsl:attribute>
			</deployment>
		</xsl:for-each>		
	</xsl:template>


	<xsl:template name="AddStereotypes">
		<xsl:param name="elementID"/>	
		<xsl:for-each select="/xmi:XMI/xmi:Extension/elements/element" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
			<xsl:if test="$elementID=@xmi:idref" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
				<xsl:if test="string-length(properties/@stereotype)&gt;0">
				<eAnnotations>
					<xsl:attribute name="xmi:id">
						<xsl:value-of select="$elementID"/><xsl:text>AN</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="source">
						<xsl:text>appliedStereotypes</xsl:text>
					</xsl:attribute>
					<contents>
						<xsl:attribute name="xmi:type">
							<xsl:value-of select="$ProfilePrefix"/><xsl:value-of select="properties/@stereotype"/>
						</xsl:attribute>
						<xsl:attribute name="xmi:id">
							<xsl:value-of select="$elementID"/><xsl:text>ST</xsl:text>
						</xsl:attribute>
					</contents>
				</eAnnotations>
				</xsl:if>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>
	
	<xsl:template name="AddStereotypesAttributes">
		<xsl:param name="elementID"/>	
		<xsl:for-each select="/xmi:XMI/xmi:Extension/elements/element/attributes/attribute" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
			<xsl:if test="$elementID=@xmi:idref" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
				<xsl:if test="string-length(stereotype/@stereotype)&gt;0">
				<eAnnotations>
					<xsl:attribute name="xmi:id">
						<xsl:value-of select="$elementID"/><xsl:text>AN</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="source">
						<xsl:text>appliedStereotypes</xsl:text>
					</xsl:attribute>
					<contents>
						<xsl:attribute name="xmi:type">
							<xsl:value-of select="$ProfilePrefix"/><xsl:value-of select="stereotype/@stereotype"/>
						</xsl:attribute>
						<xsl:attribute name="xmi:id">
							<xsl:value-of select="$elementID"/><xsl:text>ST</xsl:text>
						</xsl:attribute>
					</contents>
				</eAnnotations>
				</xsl:if>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>


	<xsl:template name="AddClassConstraints">
		<xsl:param name="elementID"/>	
		<xsl:for-each select="/xmi:XMI/xmi:Extension/elements/element" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
			<xsl:if test="$elementID=@xmi:idref" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
				<xsl:if test="string-length(constraints/constraint/@name)&gt;0">
					<ownedAttribute>
						<xsl:attribute name="name">
							<xsl:text>FeatureConstraint</xsl:text>
						</xsl:attribute>
						<xsl:attribute name="xmi:id">
							<xsl:value-of select="$elementID"/><xsl:text>AT</xsl:text>
						</xsl:attribute>
						<xsl:attribute name="isUnique">
							<xsl:text>false</xsl:text>
						</xsl:attribute>
						<type>
							<xsl:attribute name="xmi:type">
								<xsl:text>uml:PrimitiveType</xsl:text>
							</xsl:attribute>
							<xsl:attribute name="name">
								<xsl:text>String</xsl:text>
							</xsl:attribute>
						</type>
						<defaultValue>
							<xsl:attribute name="xmi:type">
								<xsl:text>uml:LiteralString</xsl:text>
							</xsl:attribute>
							<xsl:attribute name="xmi:id">
								<xsl:value-of select="$elementID"/><xsl:text>DV</xsl:text>
							</xsl:attribute>
							<xsl:attribute name="value">
								<xsl:value-of select="constraints/constraint/@name"/>
							</xsl:attribute>
						</defaultValue>
					</ownedAttribute>
				</xsl:if>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>

	<xsl:template name="AddAttributeType">
		<xsl:param name="elementIDREF"/>	
		<type>
			<xsl:attribute name="xmi:type">
				<xsl:text>uml:PrimitiveType</xsl:text>
			</xsl:attribute>

			<xsl:for-each select="/xmi:XMI/uml:Model/ownedMember/EAStub" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
				<xsl:if test="$elementIDREF=@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
					<xsl:attribute name="name">
						<xsl:value-of select="@name"/>
					</xsl:attribute>		
				</xsl:if>
			</xsl:for-each>
		</type>
	</xsl:template>
	
	<xsl:template name="AddAttributeType2">
		<xsl:param name="elementIDREF"/>	
		<xsl:for-each select="/xmi:XMI/xmi:Extension/elements/element/attributes/attribute" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
			<xsl:if test="$elementIDREF=@xmi:idref" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
				<xsl:if test="string-length(properties/@type)&gt;0">
					<type>
						<xsl:attribute name="xmi:type">
							<xsl:text>uml:PrimitiveType</xsl:text>
						</xsl:attribute>

						<xsl:attribute name="name">
							<xsl:value-of select="properties/@type"/>
						</xsl:attribute>		
					</type>
				</xsl:if>
				<xsl:if test="string-length(properties/@type) = 0">
					<type>
						<xsl:attribute name="xmi:type">
							<xsl:text>uml:PrimitiveType</xsl:text>
						</xsl:attribute>

						<xsl:attribute name="name">
							<xsl:text>defaultInteger</xsl:text>
						</xsl:attribute>		
					</type>
				</xsl:if>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>
	

	<xsl:template name="AddAssociationRoles">
		<xsl:param name="elementID"/>	
		<xsl:for-each select="//ownedMember[@xmi:type='uml:Association']" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
			<xsl:variable name="assid" select="@xmi:id" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
			<xsl:for-each select="ownedEnd">	
				<xsl:if test="$elementID=type/@xmi:idref" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
					<ownedAttribute>
						<xsl:attribute name="xmi:id">
							<xsl:value-of select="$assid"/>
							<xsl:text>FI</xsl:text>
							<xsl:if test="position()=last()"><xsl:text>LA</xsl:text></xsl:if>
						</xsl:attribute>
						<xsl:for-each select="../ownedEnd">
							<xsl:if test="$elementID=type/@xmi:idref" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
								<xsl:attribute name="name">
									<xsl:value-of select="@name"/>
								</xsl:attribute>			
							</xsl:if>
							<xsl:if test="$elementID!=type/@xmi:idref" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1">
								<xsl:attribute name="type">
									<xsl:value-of select="type/@xmi:idref" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"/>
								</xsl:attribute>			
							</xsl:if>
						</xsl:for-each>
						<xsl:attribute name="association">
							<xsl:value-of select="$assid"/>
						</xsl:attribute>
						<upperValue>
							<xsl:attribute name="xmi:type">
								<xsl:text>uml:LiteralUnlimitedNatural</xsl:text>
							</xsl:attribute>
							<xsl:attribute name="xmi:id">
								<xsl:value-of select="$assid"/>
								<xsl:text>UV</xsl:text>
								<xsl:if test="position()=last()"><xsl:text>LA</xsl:text></xsl:if>
							</xsl:attribute>
							<xsl:attribute name="value">
								<xsl:text>1</xsl:text>
							</xsl:attribute>
						</upperValue>
						<lowerValue>
							<xsl:attribute name="xmi:type">
								<xsl:text>uml:LiteralInteger</xsl:text>
							</xsl:attribute>
							<xsl:attribute name="xmi:id">
								<xsl:value-of select="$assid"/>
								<xsl:text>LV</xsl:text>
								<xsl:if test="position()=last()"><xsl:text>LA</xsl:text></xsl:if>
							</xsl:attribute>
							<xsl:attribute name="value">
								<xsl:text>1</xsl:text>
							</xsl:attribute>
						</lowerValue>
					</ownedAttribute>
				</xsl:if>
			</xsl:for-each>
		</xsl:for-each>
	</xsl:template>
</xsl:stylesheet>